attribute vec4 vertex;
attribute vec3 normal;

varying vec3 vNormal;
varying vec3 vVertex;

uniform mat4 modelViewProjectionMatrix;
uniform mat4 modelViewMatrix;
uniform mat3 normalMatrix;

void main()
{
    vNormal = normalMatrix*normal;
    vVertex = vec3(modelViewMatrix * vertex);
    gl_Position = modelViewProjectionMatrix*vertex;
}
