attribute vec4 vertex;
attribute vec3 normal;

varying vec3 vVertex;
varying vec3 vNormal;

uniform mat4 modelViewProjectionMatrix;
uniform mat4 modelViewMatrix;
uniform mat3 normalMatrix;

void main()
{
    vNormal = normalMatrix*normal;
    vVertex = vec3(modelViewMatrix * vertex);

    //stolen from sculptris , sorry :D
    vec3 nm_z = normalize(vVertex);
    vec3 nm_x = cross(nm_z, vec3(0,1,0));
    vec3 nm_y = cross(nm_x, nm_z);
    vNormal = vec3(dot(vNormal, nm_x), dot(vNormal, nm_y), dot(vNormal, nm_z));
    
    gl_Position = modelViewProjectionMatrix*vertex;
}
